;ASPECTS OF BANDLIMITING
;Ex.9, Bandlimiting using Tablekt with Midi, also adding a filter
;uses filtering employing bandlimited frequencies
;based on midi pitch numbers



<CsoundSynthesizer>
<CsOptions>

-+rtaudio=portaudio -odac 
csound -s -d -b4096 -B4096 

</CsOptions>
<CsInstruments>

sr	=	44100
kr	=	441
ksmps	=	100
nchnls	=	1


/* sawtooth wave */
i_	ftgen 30000, 0, 16384, 7, 1, 16384, -1

;tables of bw freqs based on midi nums
;GEN16 ;create a straight line function of numbers from imaxbw to 1
;for each midi pitch num up to 136 = 21,096

inum 	= sr/2
imidi 	= 12 * (log(inum/220)/log(2))+57
imidi 	= round (imidi) ;max midi num

i1  = 0
loop1:
imaxbw 	=  440.0 * exp(log(2.0) * (i1 - 69.0) / 12.0) ;convert to freq
i_	ftgen imidi - i1,  0, 4096, -16, imaxbw, 4096, 0, 1
;print i1, imaxbw 
i1	= i1 + 1
	if (i1 < imidi - 0.5) igoto loop1


;===================================================
	instr 1

kmidi = 30  ;enter a midi number

kphs phasor 0.043
kbw tablekt kphs * 4096, kmidi, 0
;printk2 kbw, 5

;convert midi pitch nums to hertz
kcps	=  440.0 * exp (log(2.0) * (kmidi - 69) / 12)

a2	oscilikt 1000, kcps, 30000 ;uses rich sawtooth only
afilt 	resonx a2, kcps, kbw, 4 ;but bw changes
asig 	balance afilt, a2

out 	asig
	endin


</CsInstruments>
<CsScore>

i1 0 23
e
</CsScore>
</CsoundSynthesizer>
